<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN">

<html lang="en">

<head>
  <meta http-equiv="Content-Type" content="text/html; charset=UTF-8">
  <title>LCOV - report.info - QtCore/qalgorithms.h</title>
  <link rel="stylesheet" type="text/css" href="../gcov.css">
</head>

<body>

  <table width="100%" border=0 cellspacing=0 cellpadding=0>
    <tr><td class="title">LCOV - code coverage report</td></tr>
    <tr><td class="ruler"><img src="../glass.png" width=3 height=3 alt=""></td></tr>

    <tr>
      <td width="100%">
        <table cellpadding=1 border=0 width="100%">
          <tr>
            <td width="10%" class="headerItem">Current view:</td>
            <td width="35%" class="headerValue"><a href="../index.html">top level</a> - <a href="index.html">QtCore</a> - qalgorithms.h<span style="font-size: 80%;"> (source / <a href="qalgorithms.h.func-sort-c.html">functions</a>)</span></td>
            <td width="5%"></td>
            <td width="15%"></td>
            <td width="10%" class="headerCovTableHead">Hit</td>
            <td width="10%" class="headerCovTableHead">Total</td>
            <td width="15%" class="headerCovTableHead">Coverage</td>
          </tr>
          <tr>
            <td class="headerItem">Test:</td>
            <td class="headerValue">report.info</td>
            <td></td>
            <td class="headerItem">Lines:</td>
            <td class="headerCovTableEntry">0</td>
            <td class="headerCovTableEntry">3</td>
            <td class="headerCovTableEntryLo">0.0 %</td>
          </tr>
          <tr>
            <td class="headerItem">Date:</td>
            <td class="headerValue">2021-03-29 02:25:54</td>
            <td></td>
            <td class="headerItem">Functions:</td>
            <td class="headerCovTableEntry">0</td>
            <td class="headerCovTableEntry">1</td>
            <td class="headerCovTableEntryLo">0.0 %</td>
          </tr>
          <tr><td><img src="../glass.png" width=3 height=3 alt=""></td></tr>
        </table>
      </td>
    </tr>

    <tr><td class="ruler"><img src="../glass.png" width=3 height=3 alt=""></td></tr>
  </table>

  <table cellpadding=0 cellspacing=0 border=0>
    <tr>
      <td><br></td>
    </tr>
    <tr>
      <td>
<pre class="sourceHeading">          Line data    Source code</pre>
<pre class="source">
<a name="1"><span class="lineNum">       1 </span>            : /****************************************************************************</a>
<a name="2"><span class="lineNum">       2 </span>            : **</a>
<a name="3"><span class="lineNum">       3 </span>            : ** Copyright (C) 2016 The Qt Company Ltd.</a>
<a name="4"><span class="lineNum">       4 </span>            : ** Contact: https://www.qt.io/licensing/</a>
<a name="5"><span class="lineNum">       5 </span>            : **</a>
<a name="6"><span class="lineNum">       6 </span>            : ** This file is part of the QtCore module of the Qt Toolkit.</a>
<a name="7"><span class="lineNum">       7 </span>            : **</a>
<a name="8"><span class="lineNum">       8 </span>            : ** $QT_BEGIN_LICENSE:LGPL$</a>
<a name="9"><span class="lineNum">       9 </span>            : ** Commercial License Usage</a>
<a name="10"><span class="lineNum">      10 </span>            : ** Licensees holding valid commercial Qt licenses may use this file in</a>
<a name="11"><span class="lineNum">      11 </span>            : ** accordance with the commercial license agreement provided with the</a>
<a name="12"><span class="lineNum">      12 </span>            : ** Software or, alternatively, in accordance with the terms contained in</a>
<a name="13"><span class="lineNum">      13 </span>            : ** a written agreement between you and The Qt Company. For licensing terms</a>
<a name="14"><span class="lineNum">      14 </span>            : ** and conditions see https://www.qt.io/terms-conditions. For further</a>
<a name="15"><span class="lineNum">      15 </span>            : ** information use the contact form at https://www.qt.io/contact-us.</a>
<a name="16"><span class="lineNum">      16 </span>            : **</a>
<a name="17"><span class="lineNum">      17 </span>            : ** GNU Lesser General Public License Usage</a>
<a name="18"><span class="lineNum">      18 </span>            : ** Alternatively, this file may be used under the terms of the GNU Lesser</a>
<a name="19"><span class="lineNum">      19 </span>            : ** General Public License version 3 as published by the Free Software</a>
<a name="20"><span class="lineNum">      20 </span>            : ** Foundation and appearing in the file LICENSE.LGPL3 included in the</a>
<a name="21"><span class="lineNum">      21 </span>            : ** packaging of this file. Please review the following information to</a>
<a name="22"><span class="lineNum">      22 </span>            : ** ensure the GNU Lesser General Public License version 3 requirements</a>
<a name="23"><span class="lineNum">      23 </span>            : ** will be met: https://www.gnu.org/licenses/lgpl-3.0.html.</a>
<a name="24"><span class="lineNum">      24 </span>            : **</a>
<a name="25"><span class="lineNum">      25 </span>            : ** GNU General Public License Usage</a>
<a name="26"><span class="lineNum">      26 </span>            : ** Alternatively, this file may be used under the terms of the GNU</a>
<a name="27"><span class="lineNum">      27 </span>            : ** General Public License version 2.0 or (at your option) the GNU General</a>
<a name="28"><span class="lineNum">      28 </span>            : ** Public license version 3 or any later version approved by the KDE Free</a>
<a name="29"><span class="lineNum">      29 </span>            : ** Qt Foundation. The licenses are as published by the Free Software</a>
<a name="30"><span class="lineNum">      30 </span>            : ** Foundation and appearing in the file LICENSE.GPL2 and LICENSE.GPL3</a>
<a name="31"><span class="lineNum">      31 </span>            : ** included in the packaging of this file. Please review the following</a>
<a name="32"><span class="lineNum">      32 </span>            : ** information to ensure the GNU General Public License requirements will</a>
<a name="33"><span class="lineNum">      33 </span>            : ** be met: https://www.gnu.org/licenses/gpl-2.0.html and</a>
<a name="34"><span class="lineNum">      34 </span>            : ** https://www.gnu.org/licenses/gpl-3.0.html.</a>
<a name="35"><span class="lineNum">      35 </span>            : **</a>
<a name="36"><span class="lineNum">      36 </span>            : ** $QT_END_LICENSE$</a>
<a name="37"><span class="lineNum">      37 </span>            : **</a>
<a name="38"><span class="lineNum">      38 </span>            : ****************************************************************************/</a>
<a name="39"><span class="lineNum">      39 </span>            : </a>
<a name="40"><span class="lineNum">      40 </span>            : #ifndef QALGORITHMS_H</a>
<a name="41"><span class="lineNum">      41 </span>            : #define QALGORITHMS_H</a>
<a name="42"><span class="lineNum">      42 </span>            : </a>
<a name="43"><span class="lineNum">      43 </span>            : #include &lt;QtCore/qglobal.h&gt;</a>
<a name="44"><span class="lineNum">      44 </span>            : </a>
<a name="45"><span class="lineNum">      45 </span>            : #ifdef Q_CC_MSVC</a>
<a name="46"><span class="lineNum">      46 </span>            : #include &lt;intrin.h&gt;</a>
<a name="47"><span class="lineNum">      47 </span>            : #endif</a>
<a name="48"><span class="lineNum">      48 </span>            : </a>
<a name="49"><span class="lineNum">      49 </span>            : QT_BEGIN_NAMESPACE</a>
<a name="50"><span class="lineNum">      50 </span>            : QT_WARNING_PUSH</a>
<a name="51"><span class="lineNum">      51 </span>            : QT_WARNING_DISABLE_DEPRECATED</a>
<a name="52"><span class="lineNum">      52 </span>            : </a>
<a name="53"><span class="lineNum">      53 </span>            : /*</a>
<a name="54"><span class="lineNum">      54 </span>            :     Warning: The contents of QAlgorithmsPrivate is not a part of the public Qt API</a>
<a name="55"><span class="lineNum">      55 </span>            :     and may be changed from version to version or even be completely removed.</a>
<a name="56"><span class="lineNum">      56 </span>            : */</a>
<a name="57"><span class="lineNum">      57 </span>            : namespace QAlgorithmsPrivate {</a>
<a name="58"><span class="lineNum">      58 </span>            : </a>
<a name="59"><span class="lineNum">      59 </span>            : #if QT_DEPRECATED_SINCE(5, 2)</a>
<a name="60"><span class="lineNum">      60 </span>            : template &lt;typename RandomAccessIterator, typename T, typename LessThan&gt;</a>
<a name="61"><span class="lineNum">      61 </span>            : QT_DEPRECATED_X(&quot;Use std::sort&quot;) Q_OUTOFLINE_TEMPLATE void qSortHelper(RandomAccessIterator start, RandomAccessIterator end, const T &amp;t, LessThan lessThan);</a>
<a name="62"><span class="lineNum">      62 </span>            : template &lt;typename RandomAccessIterator, typename T&gt;</a>
<a name="63"><span class="lineNum">      63 </span>            : QT_DEPRECATED_X(&quot;Use std::sort&quot;) inline void qSortHelper(RandomAccessIterator begin, RandomAccessIterator end, const T &amp;dummy);</a>
<a name="64"><span class="lineNum">      64 </span>            : </a>
<a name="65"><span class="lineNum">      65 </span>            : template &lt;typename RandomAccessIterator, typename T, typename LessThan&gt;</a>
<a name="66"><span class="lineNum">      66 </span>            : QT_DEPRECATED_X(&quot;Use std::stable_sort&quot;) Q_OUTOFLINE_TEMPLATE void qStableSortHelper(RandomAccessIterator start, RandomAccessIterator end, const T &amp;t, LessThan lessThan);</a>
<a name="67"><span class="lineNum">      67 </span>            : template &lt;typename RandomAccessIterator, typename T&gt;</a>
<a name="68"><span class="lineNum">      68 </span>            : QT_DEPRECATED_X(&quot;Use std::stable_sort&quot;) inline void qStableSortHelper(RandomAccessIterator, RandomAccessIterator, const T &amp;);</a>
<a name="69"><span class="lineNum">      69 </span>            : </a>
<a name="70"><span class="lineNum">      70 </span>            : template &lt;typename RandomAccessIterator, typename T, typename LessThan&gt;</a>
<a name="71"><span class="lineNum">      71 </span>            : QT_DEPRECATED_X(&quot;Use std::lower_bound&quot;) Q_OUTOFLINE_TEMPLATE RandomAccessIterator qLowerBoundHelper(RandomAccessIterator begin, RandomAccessIterator end, const T &amp;value, LessThan lessThan);</a>
<a name="72"><span class="lineNum">      72 </span>            : template &lt;typename RandomAccessIterator, typename T, typename LessThan&gt;</a>
<a name="73"><span class="lineNum">      73 </span>            : QT_DEPRECATED_X(&quot;Use std::upper_bound&quot;) Q_OUTOFLINE_TEMPLATE RandomAccessIterator qUpperBoundHelper(RandomAccessIterator begin, RandomAccessIterator end, const T &amp;value, LessThan lessThan);</a>
<a name="74"><span class="lineNum">      74 </span>            : template &lt;typename RandomAccessIterator, typename T, typename LessThan&gt;</a>
<a name="75"><span class="lineNum">      75 </span>            : QT_DEPRECATED_X(&quot;Use std::binary_search&quot;) Q_OUTOFLINE_TEMPLATE RandomAccessIterator qBinaryFindHelper(RandomAccessIterator begin, RandomAccessIterator end, const T &amp;value, LessThan lessThan);</a>
<a name="76"><span class="lineNum">      76 </span>            : #endif // QT_DEPRECATED_SINCE(5, 2)</a>
<a name="77"><span class="lineNum">      77 </span>            : </a>
<a name="78"><span class="lineNum">      78 </span>            : }</a>
<a name="79"><span class="lineNum">      79 </span>            : </a>
<a name="80"><span class="lineNum">      80 </span>            : #if QT_DEPRECATED_SINCE(5, 2)</a>
<a name="81"><span class="lineNum">      81 </span>            : template &lt;typename InputIterator, typename OutputIterator&gt;</a>
<a name="82"><span class="lineNum">      82 </span>            : QT_DEPRECATED_X(&quot;Use std::copy&quot;) inline OutputIterator qCopy(InputIterator begin, InputIterator end, OutputIterator dest)</a>
<a name="83"><span class="lineNum">      83 </span>            : {</a>
<a name="84"><span class="lineNum">      84 </span>            :     while (begin != end)</a>
<a name="85"><span class="lineNum">      85 </span>            :         *dest++ = *begin++;</a>
<a name="86"><span class="lineNum">      86 </span>            :     return dest;</a>
<a name="87"><span class="lineNum">      87 </span>            : }</a>
<a name="88"><span class="lineNum">      88 </span>            : </a>
<a name="89"><span class="lineNum">      89 </span>            : template &lt;typename BiIterator1, typename BiIterator2&gt;</a>
<a name="90"><span class="lineNum">      90 </span>            : QT_DEPRECATED_X(&quot;Use std::copy_backward&quot;) inline BiIterator2 qCopyBackward(BiIterator1 begin, BiIterator1 end, BiIterator2 dest)</a>
<a name="91"><span class="lineNum">      91 </span>            : {</a>
<a name="92"><span class="lineNum">      92 </span>            :     while (begin != end)</a>
<a name="93"><span class="lineNum">      93 </span>            :         *--dest = *--end;</a>
<a name="94"><span class="lineNum">      94 </span>            :     return dest;</a>
<a name="95"><span class="lineNum">      95 </span>            : }</a>
<a name="96"><span class="lineNum">      96 </span>            : </a>
<a name="97"><span class="lineNum">      97 </span>            : template &lt;typename InputIterator1, typename InputIterator2&gt;</a>
<a name="98"><span class="lineNum">      98 </span>            : QT_DEPRECATED_X(&quot;Use std::equal&quot;) inline bool qEqual(InputIterator1 first1, InputIterator1 last1, InputIterator2 first2)</a>
<a name="99"><span class="lineNum">      99 </span>            : {</a>
<a name="100"><span class="lineNum">     100 </span>            :     for (; first1 != last1; ++first1, ++first2)</a>
<a name="101"><span class="lineNum">     101 </span>            :         if (!(*first1 == *first2))</a>
<a name="102"><span class="lineNum">     102 </span>            :             return false;</a>
<a name="103"><span class="lineNum">     103 </span>            :     return true;</a>
<a name="104"><span class="lineNum">     104 </span>            : }</a>
<a name="105"><span class="lineNum">     105 </span>            : </a>
<a name="106"><span class="lineNum">     106 </span>            : template &lt;typename ForwardIterator, typename T&gt;</a>
<a name="107"><span class="lineNum">     107 </span>            : QT_DEPRECATED_X(&quot;Use std::fill&quot;) inline void qFill(ForwardIterator first, ForwardIterator last, const T &amp;val)</a>
<a name="108"><span class="lineNum">     108 </span>            : {</a>
<a name="109"><span class="lineNum">     109 </span>            :     for (; first != last; ++first)</a>
<a name="110"><span class="lineNum">     110 </span>            :         *first = val;</a>
<a name="111"><span class="lineNum">     111 </span>            : }</a>
<a name="112"><span class="lineNum">     112 </span>            : </a>
<a name="113"><span class="lineNum">     113 </span>            : template &lt;typename Container, typename T&gt;</a>
<a name="114"><span class="lineNum">     114 </span>            : QT_DEPRECATED_X(&quot;Use std::fill&quot;) inline void qFill(Container &amp;container, const T &amp;val)</a>
<a name="115"><span class="lineNum">     115 </span>            : {</a>
<a name="116"><span class="lineNum">     116 </span>            :     qFill(container.begin(), container.end(), val);</a>
<a name="117"><span class="lineNum">     117 </span>            : }</a>
<a name="118"><span class="lineNum">     118 </span>            : </a>
<a name="119"><span class="lineNum">     119 </span>            : template &lt;typename InputIterator, typename T&gt;</a>
<a name="120"><span class="lineNum">     120 </span>            : QT_DEPRECATED_X(&quot;Use std::find&quot;) inline InputIterator qFind(InputIterator first, InputIterator last, const T &amp;val)</a>
<a name="121"><span class="lineNum">     121 </span>            : {</a>
<a name="122"><span class="lineNum">     122 </span>            :     while (first != last &amp;&amp; !(*first == val))</a>
<a name="123"><span class="lineNum">     123 </span>            :         ++first;</a>
<a name="124"><span class="lineNum">     124 </span>            :     return first;</a>
<a name="125"><span class="lineNum">     125 </span>            : }</a>
<a name="126"><span class="lineNum">     126 </span>            : </a>
<a name="127"><span class="lineNum">     127 </span>            : template &lt;typename Container, typename T&gt;</a>
<a name="128"><span class="lineNum">     128 </span>            : QT_DEPRECATED_X(&quot;Use std::find&quot;) inline typename Container::const_iterator qFind(const Container &amp;container, const T &amp;val)</a>
<a name="129"><span class="lineNum">     129 </span>            : {</a>
<a name="130"><span class="lineNum">     130 </span>            :     return qFind(container.constBegin(), container.constEnd(), val);</a>
<a name="131"><span class="lineNum">     131 </span>            : }</a>
<a name="132"><span class="lineNum">     132 </span>            : </a>
<a name="133"><span class="lineNum">     133 </span>            : template &lt;typename InputIterator, typename T, typename Size&gt;</a>
<a name="134"><span class="lineNum">     134 </span>            : QT_DEPRECATED_X(&quot;Use std::count&quot;) inline void qCount(InputIterator first, InputIterator last, const T &amp;value, Size &amp;n)</a>
<a name="135"><span class="lineNum">     135 </span>            : {</a>
<a name="136"><span class="lineNum">     136 </span>            :     for (; first != last; ++first)</a>
<a name="137"><span class="lineNum">     137 </span>            :         if (*first == value)</a>
<a name="138"><span class="lineNum">     138 </span>            :             ++n;</a>
<a name="139"><span class="lineNum">     139 </span>            : }</a>
<a name="140"><span class="lineNum">     140 </span>            : </a>
<a name="141"><span class="lineNum">     141 </span>            : template &lt;typename Container, typename T, typename Size&gt;</a>
<a name="142"><span class="lineNum">     142 </span>            : QT_DEPRECATED_X(&quot;Use std::count&quot;) inline void qCount(const Container &amp;container, const T &amp;value, Size &amp;n)</a>
<a name="143"><span class="lineNum">     143 </span>            : {</a>
<a name="144"><span class="lineNum">     144 </span>            :     qCount(container.constBegin(), container.constEnd(), value, n);</a>
<a name="145"><span class="lineNum">     145 </span>            : }</a>
<a name="146"><span class="lineNum">     146 </span>            : </a>
<a name="147"><span class="lineNum">     147 </span>            : #ifdef Q_QDOC</a>
<a name="148"><span class="lineNum">     148 </span>            : typedef void* LessThan;</a>
<a name="149"><span class="lineNum">     149 </span>            : template &lt;typename T&gt; LessThan qLess();</a>
<a name="150"><span class="lineNum">     150 </span>            : template &lt;typename T&gt; LessThan qGreater();</a>
<a name="151"><span class="lineNum">     151 </span>            : #else</a>
<a name="152"><span class="lineNum">     152 </span>            : template &lt;typename T&gt;</a>
<a name="153"><span class="lineNum">     153 </span>            : class QT_DEPRECATED_X(&quot;Use std::less&quot;) qLess</a>
<a name="154"><span class="lineNum">     154 </span>            : {</a>
<a name="155"><span class="lineNum">     155 </span>            : public:</a>
<a name="156"><span class="lineNum">     156 </span>            :     inline bool operator()(const T &amp;t1, const T &amp;t2) const</a>
<a name="157"><span class="lineNum">     157 </span>            :     {</a>
<a name="158"><span class="lineNum">     158 </span>            :         return (t1 &lt; t2);</a>
<a name="159"><span class="lineNum">     159 </span>            :     }</a>
<a name="160"><span class="lineNum">     160 </span>            : };</a>
<a name="161"><span class="lineNum">     161 </span>            : </a>
<a name="162"><span class="lineNum">     162 </span>            : template &lt;typename T&gt;</a>
<a name="163"><span class="lineNum">     163 </span>            : class QT_DEPRECATED_X(&quot;Use std::greater&quot;) qGreater</a>
<a name="164"><span class="lineNum">     164 </span>            : {</a>
<a name="165"><span class="lineNum">     165 </span>            : public:</a>
<a name="166"><span class="lineNum">     166 </span>            :     inline bool operator()(const T &amp;t1, const T &amp;t2) const</a>
<a name="167"><span class="lineNum">     167 </span>            :     {</a>
<a name="168"><span class="lineNum">     168 </span>            :         return (t2 &lt; t1);</a>
<a name="169"><span class="lineNum">     169 </span>            :     }</a>
<a name="170"><span class="lineNum">     170 </span>            : };</a>
<a name="171"><span class="lineNum">     171 </span>            : #endif</a>
<a name="172"><span class="lineNum">     172 </span>            : </a>
<a name="173"><span class="lineNum">     173 </span>            : template &lt;typename RandomAccessIterator&gt;</a>
<a name="174"><span class="lineNum">     174 </span>            : QT_DEPRECATED_X(&quot;Use std::sort&quot;) inline void qSort(RandomAccessIterator start, RandomAccessIterator end)</a>
<a name="175"><span class="lineNum">     175 </span>            : {</a>
<a name="176"><span class="lineNum">     176 </span>            :     if (start != end)</a>
<a name="177"><span class="lineNum">     177 </span>            :         QAlgorithmsPrivate::qSortHelper(start, end, *start);</a>
<a name="178"><span class="lineNum">     178 </span>            : }</a>
<a name="179"><span class="lineNum">     179 </span>            : </a>
<a name="180"><span class="lineNum">     180 </span>            : template &lt;typename RandomAccessIterator, typename LessThan&gt;</a>
<a name="181"><span class="lineNum">     181 </span>            : QT_DEPRECATED_X(&quot;Use std::sort&quot;) inline void qSort(RandomAccessIterator start, RandomAccessIterator end, LessThan lessThan)</a>
<a name="182"><span class="lineNum">     182 </span>            : {</a>
<a name="183"><span class="lineNum">     183 </span>            :     if (start != end)</a>
<a name="184"><span class="lineNum">     184 </span>            :         QAlgorithmsPrivate::qSortHelper(start, end, *start, lessThan);</a>
<a name="185"><span class="lineNum">     185 </span>            : }</a>
<a name="186"><span class="lineNum">     186 </span>            : </a>
<a name="187"><span class="lineNum">     187 </span>            : template&lt;typename Container&gt;</a>
<a name="188"><span class="lineNum">     188 </span>            : QT_DEPRECATED_X(&quot;Use std::sort&quot;) inline void qSort(Container &amp;c)</a>
<a name="189"><span class="lineNum">     189 </span>            : {</a>
<a name="190"><span class="lineNum">     190 </span>            : #ifdef Q_CC_BOR</a>
<a name="191"><span class="lineNum">     191 </span>            :     // Work around Borland 5.5 optimizer bug</a>
<a name="192"><span class="lineNum">     192 </span>            :     c.detach();</a>
<a name="193"><span class="lineNum">     193 </span>            : #endif</a>
<a name="194"><span class="lineNum">     194 </span>            :     if (!c.empty())</a>
<a name="195"><span class="lineNum">     195 </span>            :         QAlgorithmsPrivate::qSortHelper(c.begin(), c.end(), *c.begin());</a>
<a name="196"><span class="lineNum">     196 </span>            : }</a>
<a name="197"><span class="lineNum">     197 </span>            : </a>
<a name="198"><span class="lineNum">     198 </span>            : template &lt;typename RandomAccessIterator&gt;</a>
<a name="199"><span class="lineNum">     199 </span>            : QT_DEPRECATED_X(&quot;Use std::stable_sort&quot;) inline void qStableSort(RandomAccessIterator start, RandomAccessIterator end)</a>
<a name="200"><span class="lineNum">     200 </span>            : {</a>
<a name="201"><span class="lineNum">     201 </span>            :     if (start != end)</a>
<a name="202"><span class="lineNum">     202 </span>            :         QAlgorithmsPrivate::qStableSortHelper(start, end, *start);</a>
<a name="203"><span class="lineNum">     203 </span>            : }</a>
<a name="204"><span class="lineNum">     204 </span>            : </a>
<a name="205"><span class="lineNum">     205 </span>            : template &lt;typename RandomAccessIterator, typename LessThan&gt;</a>
<a name="206"><span class="lineNum">     206 </span>            : QT_DEPRECATED_X(&quot;Use std::stable_sort&quot;) inline void qStableSort(RandomAccessIterator start, RandomAccessIterator end, LessThan lessThan)</a>
<a name="207"><span class="lineNum">     207 </span>            : {</a>
<a name="208"><span class="lineNum">     208 </span>            :     if (start != end)</a>
<a name="209"><span class="lineNum">     209 </span>            :         QAlgorithmsPrivate::qStableSortHelper(start, end, *start, lessThan);</a>
<a name="210"><span class="lineNum">     210 </span>            : }</a>
<a name="211"><span class="lineNum">     211 </span>            : </a>
<a name="212"><span class="lineNum">     212 </span>            : template&lt;typename Container&gt;</a>
<a name="213"><span class="lineNum">     213 </span>            : QT_DEPRECATED_X(&quot;Use std::stable_sort&quot;) inline void qStableSort(Container &amp;c)</a>
<a name="214"><span class="lineNum">     214 </span>            : {</a>
<a name="215"><span class="lineNum">     215 </span>            : #ifdef Q_CC_BOR</a>
<a name="216"><span class="lineNum">     216 </span>            :     // Work around Borland 5.5 optimizer bug</a>
<a name="217"><span class="lineNum">     217 </span>            :     c.detach();</a>
<a name="218"><span class="lineNum">     218 </span>            : #endif</a>
<a name="219"><span class="lineNum">     219 </span>            :     if (!c.empty())</a>
<a name="220"><span class="lineNum">     220 </span>            :         QAlgorithmsPrivate::qStableSortHelper(c.begin(), c.end(), *c.begin());</a>
<a name="221"><span class="lineNum">     221 </span>            : }</a>
<a name="222"><span class="lineNum">     222 </span>            : </a>
<a name="223"><span class="lineNum">     223 </span>            : template &lt;typename RandomAccessIterator, typename T&gt;</a>
<a name="224"><span class="lineNum">     224 </span>            : QT_DEPRECATED_X(&quot;Use std::lower_bound&quot;) Q_OUTOFLINE_TEMPLATE RandomAccessIterator qLowerBound(RandomAccessIterator begin, RandomAccessIterator end, const T &amp;value)</a>
<a name="225"><span class="lineNum">     225 </span>            : {</a>
<a name="226"><span class="lineNum">     226 </span>            :     // Implementation is duplicated from QAlgorithmsPrivate to keep existing code</a>
<a name="227"><span class="lineNum">     227 </span>            :     // compiling. We have to allow using *begin and value with different types,</a>
<a name="228"><span class="lineNum">     228 </span>            :     // and then implementing operator&lt; for those types.</a>
<a name="229"><span class="lineNum">     229 </span>            :     RandomAccessIterator middle;</a>
<a name="230"><span class="lineNum">     230 </span>            :     int n = end - begin;</a>
<a name="231"><span class="lineNum">     231 </span>            :     int half;</a>
<a name="232"><span class="lineNum">     232 </span>            : </a>
<a name="233"><span class="lineNum">     233 </span>            :     while (n &gt; 0) {</a>
<a name="234"><span class="lineNum">     234 </span>            :         half = n &gt;&gt; 1;</a>
<a name="235"><span class="lineNum">     235 </span>            :         middle = begin + half;</a>
<a name="236"><span class="lineNum">     236 </span>            :         if (*middle &lt; value) {</a>
<a name="237"><span class="lineNum">     237 </span>            :             begin = middle + 1;</a>
<a name="238"><span class="lineNum">     238 </span>            :             n -= half + 1;</a>
<a name="239"><span class="lineNum">     239 </span>            :         } else {</a>
<a name="240"><span class="lineNum">     240 </span>            :             n = half;</a>
<a name="241"><span class="lineNum">     241 </span>            :         }</a>
<a name="242"><span class="lineNum">     242 </span>            :     }</a>
<a name="243"><span class="lineNum">     243 </span>            :     return begin;</a>
<a name="244"><span class="lineNum">     244 </span>            : }</a>
<a name="245"><span class="lineNum">     245 </span>            : </a>
<a name="246"><span class="lineNum">     246 </span>            : template &lt;typename RandomAccessIterator, typename T, typename LessThan&gt;</a>
<a name="247"><span class="lineNum">     247 </span>            : QT_DEPRECATED_X(&quot;Use std::lower_bound&quot;) Q_OUTOFLINE_TEMPLATE RandomAccessIterator qLowerBound(RandomAccessIterator begin, RandomAccessIterator end, const T &amp;value, LessThan lessThan)</a>
<a name="248"><span class="lineNum">     248 </span>            : {</a>
<a name="249"><span class="lineNum">     249 </span>            :     return QAlgorithmsPrivate::qLowerBoundHelper(begin, end, value, lessThan);</a>
<a name="250"><span class="lineNum">     250 </span>            : }</a>
<a name="251"><span class="lineNum">     251 </span>            : </a>
<a name="252"><span class="lineNum">     252 </span>            : template &lt;typename Container, typename T&gt;</a>
<a name="253"><span class="lineNum">     253 </span>            : QT_DEPRECATED_X(&quot;Use std::lower_bound&quot;) Q_OUTOFLINE_TEMPLATE typename Container::const_iterator qLowerBound(const Container &amp;container, const T &amp;value)</a>
<a name="254"><span class="lineNum">     254 </span>            : {</a>
<a name="255"><span class="lineNum">     255 </span>            :     return QAlgorithmsPrivate::qLowerBoundHelper(container.constBegin(), container.constEnd(), value, qLess&lt;T&gt;());</a>
<a name="256"><span class="lineNum">     256 </span>            : }</a>
<a name="257"><span class="lineNum">     257 </span>            : </a>
<a name="258"><span class="lineNum">     258 </span>            : template &lt;typename RandomAccessIterator, typename T&gt;</a>
<a name="259"><span class="lineNum">     259 </span>            : QT_DEPRECATED_X(&quot;Use std::upper_bound&quot;) Q_OUTOFLINE_TEMPLATE RandomAccessIterator qUpperBound(RandomAccessIterator begin, RandomAccessIterator end, const T &amp;value)</a>
<a name="260"><span class="lineNum">     260 </span>            : {</a>
<a name="261"><span class="lineNum">     261 </span>            :     // Implementation is duplicated from QAlgorithmsPrivate.</a>
<a name="262"><span class="lineNum">     262 </span>            :     RandomAccessIterator middle;</a>
<a name="263"><span class="lineNum">     263 </span>            :     int n = end - begin;</a>
<a name="264"><span class="lineNum">     264 </span>            :     int half;</a>
<a name="265"><span class="lineNum">     265 </span>            : </a>
<a name="266"><span class="lineNum">     266 </span>            :     while (n &gt; 0) {</a>
<a name="267"><span class="lineNum">     267 </span>            :         half = n &gt;&gt; 1;</a>
<a name="268"><span class="lineNum">     268 </span>            :         middle = begin + half;</a>
<a name="269"><span class="lineNum">     269 </span>            :         if (value &lt; *middle) {</a>
<a name="270"><span class="lineNum">     270 </span>            :             n = half;</a>
<a name="271"><span class="lineNum">     271 </span>            :         } else {</a>
<a name="272"><span class="lineNum">     272 </span>            :             begin = middle + 1;</a>
<a name="273"><span class="lineNum">     273 </span>            :             n -= half + 1;</a>
<a name="274"><span class="lineNum">     274 </span>            :         }</a>
<a name="275"><span class="lineNum">     275 </span>            :     }</a>
<a name="276"><span class="lineNum">     276 </span>            :     return begin;</a>
<a name="277"><span class="lineNum">     277 </span>            : }</a>
<a name="278"><span class="lineNum">     278 </span>            : </a>
<a name="279"><span class="lineNum">     279 </span>            : template &lt;typename RandomAccessIterator, typename T, typename LessThan&gt;</a>
<a name="280"><span class="lineNum">     280 </span>            : QT_DEPRECATED_X(&quot;Use std::upper_bound&quot;) Q_OUTOFLINE_TEMPLATE RandomAccessIterator qUpperBound(RandomAccessIterator begin, RandomAccessIterator end, const T &amp;value, LessThan lessThan)</a>
<a name="281"><span class="lineNum">     281 </span>            : {</a>
<a name="282"><span class="lineNum">     282 </span>            :     return QAlgorithmsPrivate::qUpperBoundHelper(begin, end, value, lessThan);</a>
<a name="283"><span class="lineNum">     283 </span>            : }</a>
<a name="284"><span class="lineNum">     284 </span>            : </a>
<a name="285"><span class="lineNum">     285 </span>            : template &lt;typename Container, typename T&gt;</a>
<a name="286"><span class="lineNum">     286 </span>            : QT_DEPRECATED_X(&quot;Use std::upper_bound&quot;) Q_OUTOFLINE_TEMPLATE typename Container::const_iterator qUpperBound(const Container &amp;container, const T &amp;value)</a>
<a name="287"><span class="lineNum">     287 </span>            : {</a>
<a name="288"><span class="lineNum">     288 </span>            :     return QAlgorithmsPrivate::qUpperBoundHelper(container.constBegin(), container.constEnd(), value, qLess&lt;T&gt;());</a>
<a name="289"><span class="lineNum">     289 </span>            : }</a>
<a name="290"><span class="lineNum">     290 </span>            : </a>
<a name="291"><span class="lineNum">     291 </span>            : template &lt;typename RandomAccessIterator, typename T&gt;</a>
<a name="292"><span class="lineNum">     292 </span>            : QT_DEPRECATED_X(&quot;Use std::binary_search&quot;) Q_OUTOFLINE_TEMPLATE RandomAccessIterator qBinaryFind(RandomAccessIterator begin, RandomAccessIterator end, const T &amp;value)</a>
<a name="293"><span class="lineNum">     293 </span>            : {</a>
<a name="294"><span class="lineNum">     294 </span>            :     // Implementation is duplicated from QAlgorithmsPrivate.</a>
<a name="295"><span class="lineNum">     295 </span>            :     RandomAccessIterator it = qLowerBound(begin, end, value);</a>
<a name="296"><span class="lineNum">     296 </span>            : </a>
<a name="297"><span class="lineNum">     297 </span>            :     if (it == end || value &lt; *it)</a>
<a name="298"><span class="lineNum">     298 </span>            :         return end;</a>
<a name="299"><span class="lineNum">     299 </span>            : </a>
<a name="300"><span class="lineNum">     300 </span>            :     return it;</a>
<a name="301"><span class="lineNum">     301 </span>            : }</a>
<a name="302"><span class="lineNum">     302 </span>            : </a>
<a name="303"><span class="lineNum">     303 </span>            : template &lt;typename RandomAccessIterator, typename T, typename LessThan&gt;</a>
<a name="304"><span class="lineNum">     304 </span>            : QT_DEPRECATED_X(&quot;Use std::binary_search&quot;) Q_OUTOFLINE_TEMPLATE RandomAccessIterator qBinaryFind(RandomAccessIterator begin, RandomAccessIterator end, const T &amp;value, LessThan lessThan)</a>
<a name="305"><span class="lineNum">     305 </span>            : {</a>
<a name="306"><span class="lineNum">     306 </span>            :     return QAlgorithmsPrivate::qBinaryFindHelper(begin, end, value, lessThan);</a>
<a name="307"><span class="lineNum">     307 </span>            : }</a>
<a name="308"><span class="lineNum">     308 </span>            : </a>
<a name="309"><span class="lineNum">     309 </span>            : template &lt;typename Container, typename T&gt;</a>
<a name="310"><span class="lineNum">     310 </span>            : QT_DEPRECATED_X(&quot;Use std::binary_search&quot;) Q_OUTOFLINE_TEMPLATE typename Container::const_iterator qBinaryFind(const Container &amp;container, const T &amp;value)</a>
<a name="311"><span class="lineNum">     311 </span>            : {</a>
<a name="312"><span class="lineNum">     312 </span>            :     return QAlgorithmsPrivate::qBinaryFindHelper(container.constBegin(), container.constEnd(), value, qLess&lt;T&gt;());</a>
<a name="313"><span class="lineNum">     313 </span>            : }</a>
<a name="314"><span class="lineNum">     314 </span>            : #endif // QT_DEPRECATED_SINCE(5, 2)</a>
<a name="315"><span class="lineNum">     315 </span>            : </a>
<a name="316"><span class="lineNum">     316 </span>            : template &lt;typename ForwardIterator&gt;</a>
<a name="317"><span class="lineNum">     317 </span>            : Q_OUTOFLINE_TEMPLATE void qDeleteAll(ForwardIterator begin, ForwardIterator end)</a>
<a name="318"><span class="lineNum">     318 </span>            : {</a>
<a name="319"><span class="lineNum">     319 </span>            :     while (begin != end) {</a>
<a name="320"><span class="lineNum">     320 </span>            :         delete *begin;</a>
<a name="321"><span class="lineNum">     321 </span>            :         ++begin;</a>
<a name="322"><span class="lineNum">     322 </span>            :     }</a>
<a name="323"><span class="lineNum">     323 </span>            : }</a>
<a name="324"><span class="lineNum">     324 </span>            : </a>
<a name="325"><span class="lineNum">     325 </span>            : template &lt;typename Container&gt;</a>
<a name="326"><span class="lineNum">     326 </span>            : inline void qDeleteAll(const Container &amp;c)</a>
<a name="327"><span class="lineNum">     327 </span>            : {</a>
<a name="328"><span class="lineNum">     328 </span>            :     qDeleteAll(c.begin(), c.end());</a>
<a name="329"><span class="lineNum">     329 </span>            : }</a>
<a name="330"><span class="lineNum">     330 </span>            : </a>
<a name="331"><span class="lineNum">     331 </span>            : /*</a>
<a name="332"><span class="lineNum">     332 </span>            :     Warning: The contents of QAlgorithmsPrivate is not a part of the public Qt API</a>
<a name="333"><span class="lineNum">     333 </span>            :     and may be changed from version to version or even be completely removed.</a>
<a name="334"><span class="lineNum">     334 </span>            : */</a>
<a name="335"><span class="lineNum">     335 </span>            : namespace QAlgorithmsPrivate {</a>
<a name="336"><span class="lineNum">     336 </span>            : </a>
<a name="337"><span class="lineNum">     337 </span>            : #if QT_DEPRECATED_SINCE(5, 2)</a>
<a name="338"><span class="lineNum">     338 </span>            : </a>
<a name="339"><span class="lineNum">     339 </span>            : template &lt;typename RandomAccessIterator, typename T, typename LessThan&gt;</a>
<a name="340"><span class="lineNum">     340 </span>            : QT_DEPRECATED_X(&quot;Use std::sort&quot;) Q_OUTOFLINE_TEMPLATE void qSortHelper(RandomAccessIterator start, RandomAccessIterator end, const T &amp;t, LessThan lessThan)</a>
<a name="341"><span class="lineNum">     341 </span>            : {</a>
<a name="342"><span class="lineNum">     342 </span>            : top:</a>
<a name="343"><span class="lineNum">     343 </span>            :     int span = int(end - start);</a>
<a name="344"><span class="lineNum">     344 </span>            :     if (span &lt; 2)</a>
<a name="345"><span class="lineNum">     345 </span>            :         return;</a>
<a name="346"><span class="lineNum">     346 </span>            : </a>
<a name="347"><span class="lineNum">     347 </span>            :     --end;</a>
<a name="348"><span class="lineNum">     348 </span>            :     RandomAccessIterator low = start, high = end - 1;</a>
<a name="349"><span class="lineNum">     349 </span>            :     RandomAccessIterator pivot = start + span / 2;</a>
<a name="350"><span class="lineNum">     350 </span>            : </a>
<a name="351"><span class="lineNum">     351 </span>            :     if (lessThan(*end, *start))</a>
<a name="352"><span class="lineNum">     352 </span>            :         qSwap(*end, *start);</a>
<a name="353"><span class="lineNum">     353 </span>            :     if (span == 2)</a>
<a name="354"><span class="lineNum">     354 </span>            :         return;</a>
<a name="355"><span class="lineNum">     355 </span>            : </a>
<a name="356"><span class="lineNum">     356 </span>            :     if (lessThan(*pivot, *start))</a>
<a name="357"><span class="lineNum">     357 </span>            :         qSwap(*pivot, *start);</a>
<a name="358"><span class="lineNum">     358 </span>            :     if (lessThan(*end, *pivot))</a>
<a name="359"><span class="lineNum">     359 </span>            :         qSwap(*end, *pivot);</a>
<a name="360"><span class="lineNum">     360 </span>            :     if (span == 3)</a>
<a name="361"><span class="lineNum">     361 </span>            :         return;</a>
<a name="362"><span class="lineNum">     362 </span>            : </a>
<a name="363"><span class="lineNum">     363 </span>            :     qSwap(*pivot, *end);</a>
<a name="364"><span class="lineNum">     364 </span>            : </a>
<a name="365"><span class="lineNum">     365 </span>            :     while (low &lt; high) {</a>
<a name="366"><span class="lineNum">     366 </span>            :         while (low &lt; high &amp;&amp; lessThan(*low, *end))</a>
<a name="367"><span class="lineNum">     367 </span>            :             ++low;</a>
<a name="368"><span class="lineNum">     368 </span>            : </a>
<a name="369"><span class="lineNum">     369 </span>            :         while (high &gt; low &amp;&amp; lessThan(*end, *high))</a>
<a name="370"><span class="lineNum">     370 </span>            :             --high;</a>
<a name="371"><span class="lineNum">     371 </span>            : </a>
<a name="372"><span class="lineNum">     372 </span>            :         if (low &lt; high) {</a>
<a name="373"><span class="lineNum">     373 </span>            :             qSwap(*low, *high);</a>
<a name="374"><span class="lineNum">     374 </span>            :             ++low;</a>
<a name="375"><span class="lineNum">     375 </span>            :             --high;</a>
<a name="376"><span class="lineNum">     376 </span>            :         } else {</a>
<a name="377"><span class="lineNum">     377 </span>            :             break;</a>
<a name="378"><span class="lineNum">     378 </span>            :         }</a>
<a name="379"><span class="lineNum">     379 </span>            :     }</a>
<a name="380"><span class="lineNum">     380 </span>            : </a>
<a name="381"><span class="lineNum">     381 </span>            :     if (lessThan(*low, *end))</a>
<a name="382"><span class="lineNum">     382 </span>            :         ++low;</a>
<a name="383"><span class="lineNum">     383 </span>            : </a>
<a name="384"><span class="lineNum">     384 </span>            :     qSwap(*end, *low);</a>
<a name="385"><span class="lineNum">     385 </span>            :     qSortHelper(start, low, t, lessThan);</a>
<a name="386"><span class="lineNum">     386 </span>            : </a>
<a name="387"><span class="lineNum">     387 </span>            :     start = low + 1;</a>
<a name="388"><span class="lineNum">     388 </span>            :     ++end;</a>
<a name="389"><span class="lineNum">     389 </span>            :     goto top;</a>
<a name="390"><span class="lineNum">     390 </span>            : }</a>
<a name="391"><span class="lineNum">     391 </span>            : </a>
<a name="392"><span class="lineNum">     392 </span>            : template &lt;typename RandomAccessIterator, typename T&gt;</a>
<a name="393"><span class="lineNum">     393 </span>            : QT_DEPRECATED_X(&quot;Use std::sort&quot;) inline void qSortHelper(RandomAccessIterator begin, RandomAccessIterator end, const T &amp;dummy)</a>
<a name="394"><span class="lineNum">     394 </span>            : {</a>
<a name="395"><span class="lineNum">     395 </span>            :     qSortHelper(begin, end, dummy, qLess&lt;T&gt;());</a>
<a name="396"><span class="lineNum">     396 </span>            : }</a>
<a name="397"><span class="lineNum">     397 </span>            : </a>
<a name="398"><span class="lineNum">     398 </span>            : template &lt;typename RandomAccessIterator&gt;</a>
<a name="399"><span class="lineNum">     399 </span>            : QT_DEPRECATED_X(&quot;Use std::reverse&quot;) Q_OUTOFLINE_TEMPLATE void qReverse(RandomAccessIterator begin, RandomAccessIterator end)</a>
<a name="400"><span class="lineNum">     400 </span>            : {</a>
<a name="401"><span class="lineNum">     401 </span>            :     --end;</a>
<a name="402"><span class="lineNum">     402 </span>            :     while (begin &lt; end)</a>
<a name="403"><span class="lineNum">     403 </span>            :         qSwap(*begin++, *end--);</a>
<a name="404"><span class="lineNum">     404 </span>            : }</a>
<a name="405"><span class="lineNum">     405 </span>            : </a>
<a name="406"><span class="lineNum">     406 </span>            : template &lt;typename RandomAccessIterator&gt;</a>
<a name="407"><span class="lineNum">     407 </span>            : QT_DEPRECATED_X(&quot;Use std::rotate&quot;) Q_OUTOFLINE_TEMPLATE void qRotate(RandomAccessIterator begin, RandomAccessIterator middle, RandomAccessIterator end)</a>
<a name="408"><span class="lineNum">     408 </span>            : {</a>
<a name="409"><span class="lineNum">     409 </span>            :     qReverse(begin, middle);</a>
<a name="410"><span class="lineNum">     410 </span>            :     qReverse(middle, end);</a>
<a name="411"><span class="lineNum">     411 </span>            :     qReverse(begin, end);</a>
<a name="412"><span class="lineNum">     412 </span>            : }</a>
<a name="413"><span class="lineNum">     413 </span>            : </a>
<a name="414"><span class="lineNum">     414 </span>            : template &lt;typename RandomAccessIterator, typename T, typename LessThan&gt;</a>
<a name="415"><span class="lineNum">     415 </span>            : QT_DEPRECATED_X(&quot;Use std::merge&quot;) Q_OUTOFLINE_TEMPLATE void qMerge(RandomAccessIterator begin, RandomAccessIterator pivot, RandomAccessIterator end, T &amp;t, LessThan lessThan)</a>
<a name="416"><span class="lineNum">     416 </span>            : {</a>
<a name="417"><span class="lineNum">     417 </span>            :     const int len1 = pivot - begin;</a>
<a name="418"><span class="lineNum">     418 </span>            :     const int len2 = end - pivot;</a>
<a name="419"><span class="lineNum">     419 </span>            : </a>
<a name="420"><span class="lineNum">     420 </span>            :     if (len1 == 0 || len2 == 0)</a>
<a name="421"><span class="lineNum">     421 </span>            :         return;</a>
<a name="422"><span class="lineNum">     422 </span>            : </a>
<a name="423"><span class="lineNum">     423 </span>            :     if (len1 + len2 == 2) {</a>
<a name="424"><span class="lineNum">     424 </span>            :         if (lessThan(*(begin + 1), *(begin)))</a>
<a name="425"><span class="lineNum">     425 </span>            :             qSwap(*begin, *(begin + 1));</a>
<a name="426"><span class="lineNum">     426 </span>            :         return;</a>
<a name="427"><span class="lineNum">     427 </span>            :     }</a>
<a name="428"><span class="lineNum">     428 </span>            : </a>
<a name="429"><span class="lineNum">     429 </span>            :     RandomAccessIterator firstCut;</a>
<a name="430"><span class="lineNum">     430 </span>            :     RandomAccessIterator secondCut;</a>
<a name="431"><span class="lineNum">     431 </span>            :     int len2Half;</a>
<a name="432"><span class="lineNum">     432 </span>            :     if (len1 &gt; len2) {</a>
<a name="433"><span class="lineNum">     433 </span>            :         const int len1Half = len1 / 2;</a>
<a name="434"><span class="lineNum">     434 </span>            :         firstCut = begin + len1Half;</a>
<a name="435"><span class="lineNum">     435 </span>            :         secondCut = qLowerBound(pivot, end, *firstCut, lessThan);</a>
<a name="436"><span class="lineNum">     436 </span>            :         len2Half = secondCut - pivot;</a>
<a name="437"><span class="lineNum">     437 </span>            :     } else {</a>
<a name="438"><span class="lineNum">     438 </span>            :         len2Half = len2 / 2;</a>
<a name="439"><span class="lineNum">     439 </span>            :         secondCut = pivot + len2Half;</a>
<a name="440"><span class="lineNum">     440 </span>            :         firstCut = qUpperBound(begin, pivot, *secondCut, lessThan);</a>
<a name="441"><span class="lineNum">     441 </span>            :     }</a>
<a name="442"><span class="lineNum">     442 </span>            : </a>
<a name="443"><span class="lineNum">     443 </span>            :     qRotate(firstCut, pivot, secondCut);</a>
<a name="444"><span class="lineNum">     444 </span>            :     const RandomAccessIterator newPivot = firstCut + len2Half;</a>
<a name="445"><span class="lineNum">     445 </span>            :     qMerge(begin, firstCut, newPivot, t, lessThan);</a>
<a name="446"><span class="lineNum">     446 </span>            :     qMerge(newPivot, secondCut, end, t, lessThan);</a>
<a name="447"><span class="lineNum">     447 </span>            : }</a>
<a name="448"><span class="lineNum">     448 </span>            : </a>
<a name="449"><span class="lineNum">     449 </span>            : template &lt;typename RandomAccessIterator, typename T, typename LessThan&gt;</a>
<a name="450"><span class="lineNum">     450 </span>            : QT_DEPRECATED_X(&quot;Use std::stable_sort&quot;) Q_OUTOFLINE_TEMPLATE void qStableSortHelper(RandomAccessIterator begin, RandomAccessIterator end, const T &amp;t, LessThan lessThan)</a>
<a name="451"><span class="lineNum">     451 </span>            : {</a>
<a name="452"><span class="lineNum">     452 </span>            :     const int span = end - begin;</a>
<a name="453"><span class="lineNum">     453 </span>            :     if (span &lt; 2)</a>
<a name="454"><span class="lineNum">     454 </span>            :        return;</a>
<a name="455"><span class="lineNum">     455 </span>            : </a>
<a name="456"><span class="lineNum">     456 </span>            :     const RandomAccessIterator middle = begin + span / 2;</a>
<a name="457"><span class="lineNum">     457 </span>            :     qStableSortHelper(begin, middle, t, lessThan);</a>
<a name="458"><span class="lineNum">     458 </span>            :     qStableSortHelper(middle, end, t, lessThan);</a>
<a name="459"><span class="lineNum">     459 </span>            :     qMerge(begin, middle, end, t, lessThan);</a>
<a name="460"><span class="lineNum">     460 </span>            : }</a>
<a name="461"><span class="lineNum">     461 </span>            : </a>
<a name="462"><span class="lineNum">     462 </span>            : template &lt;typename RandomAccessIterator, typename T&gt;</a>
<a name="463"><span class="lineNum">     463 </span>            : QT_DEPRECATED_X(&quot;Use std::stable_sort&quot;) inline void qStableSortHelper(RandomAccessIterator begin, RandomAccessIterator end, const T &amp;dummy)</a>
<a name="464"><span class="lineNum">     464 </span>            : {</a>
<a name="465"><span class="lineNum">     465 </span>            :     qStableSortHelper(begin, end, dummy, qLess&lt;T&gt;());</a>
<a name="466"><span class="lineNum">     466 </span>            : }</a>
<a name="467"><span class="lineNum">     467 </span>            : </a>
<a name="468"><span class="lineNum">     468 </span>            : template &lt;typename RandomAccessIterator, typename T, typename LessThan&gt;</a>
<a name="469"><span class="lineNum">     469 </span>            : QT_DEPRECATED_X(&quot;Use std::lower_bound&quot;) Q_OUTOFLINE_TEMPLATE RandomAccessIterator qLowerBoundHelper(RandomAccessIterator begin, RandomAccessIterator end, const T &amp;value, LessThan lessThan)</a>
<a name="470"><span class="lineNum">     470 </span>            : {</a>
<a name="471"><span class="lineNum">     471 </span>            :     RandomAccessIterator middle;</a>
<a name="472"><span class="lineNum">     472 </span>            :     int n = int(end - begin);</a>
<a name="473"><span class="lineNum">     473 </span>            :     int half;</a>
<a name="474"><span class="lineNum">     474 </span>            : </a>
<a name="475"><span class="lineNum">     475 </span>            :     while (n &gt; 0) {</a>
<a name="476"><span class="lineNum">     476 </span>            :         half = n &gt;&gt; 1;</a>
<a name="477"><span class="lineNum">     477 </span>            :         middle = begin + half;</a>
<a name="478"><span class="lineNum">     478 </span>            :         if (lessThan(*middle, value)) {</a>
<a name="479"><span class="lineNum">     479 </span>            :             begin = middle + 1;</a>
<a name="480"><span class="lineNum">     480 </span>            :             n -= half + 1;</a>
<a name="481"><span class="lineNum">     481 </span>            :         } else {</a>
<a name="482"><span class="lineNum">     482 </span>            :             n = half;</a>
<a name="483"><span class="lineNum">     483 </span>            :         }</a>
<a name="484"><span class="lineNum">     484 </span>            :     }</a>
<a name="485"><span class="lineNum">     485 </span>            :     return begin;</a>
<a name="486"><span class="lineNum">     486 </span>            : }</a>
<a name="487"><span class="lineNum">     487 </span>            : </a>
<a name="488"><span class="lineNum">     488 </span>            : </a>
<a name="489"><span class="lineNum">     489 </span>            : template &lt;typename RandomAccessIterator, typename T, typename LessThan&gt;</a>
<a name="490"><span class="lineNum">     490 </span>            : QT_DEPRECATED_X(&quot;Use std::upper_bound&quot;) Q_OUTOFLINE_TEMPLATE RandomAccessIterator qUpperBoundHelper(RandomAccessIterator begin, RandomAccessIterator end, const T &amp;value, LessThan lessThan)</a>
<a name="491"><span class="lineNum">     491 </span>            : {</a>
<a name="492"><span class="lineNum">     492 </span>            :     RandomAccessIterator middle;</a>
<a name="493"><span class="lineNum">     493 </span>            :     int n = end - begin;</a>
<a name="494"><span class="lineNum">     494 </span>            :     int half;</a>
<a name="495"><span class="lineNum">     495 </span>            : </a>
<a name="496"><span class="lineNum">     496 </span>            :     while (n &gt; 0) {</a>
<a name="497"><span class="lineNum">     497 </span>            :         half = n &gt;&gt; 1;</a>
<a name="498"><span class="lineNum">     498 </span>            :         middle = begin + half;</a>
<a name="499"><span class="lineNum">     499 </span>            :         if (lessThan(value, *middle)) {</a>
<a name="500"><span class="lineNum">     500 </span>            :             n = half;</a>
<a name="501"><span class="lineNum">     501 </span>            :         } else {</a>
<a name="502"><span class="lineNum">     502 </span>            :             begin = middle + 1;</a>
<a name="503"><span class="lineNum">     503 </span>            :             n -= half + 1;</a>
<a name="504"><span class="lineNum">     504 </span>            :         }</a>
<a name="505"><span class="lineNum">     505 </span>            :     }</a>
<a name="506"><span class="lineNum">     506 </span>            :     return begin;</a>
<a name="507"><span class="lineNum">     507 </span>            : }</a>
<a name="508"><span class="lineNum">     508 </span>            : </a>
<a name="509"><span class="lineNum">     509 </span>            : template &lt;typename RandomAccessIterator, typename T, typename LessThan&gt;</a>
<a name="510"><span class="lineNum">     510 </span>            : QT_DEPRECATED_X(&quot;Use std::binary_search&quot;) Q_OUTOFLINE_TEMPLATE RandomAccessIterator qBinaryFindHelper(RandomAccessIterator begin, RandomAccessIterator end, const T &amp;value, LessThan lessThan)</a>
<a name="511"><span class="lineNum">     511 </span>            : {</a>
<a name="512"><span class="lineNum">     512 </span>            :     RandomAccessIterator it = qLowerBoundHelper(begin, end, value, lessThan);</a>
<a name="513"><span class="lineNum">     513 </span>            : </a>
<a name="514"><span class="lineNum">     514 </span>            :     if (it == end || lessThan(value, *it))</a>
<a name="515"><span class="lineNum">     515 </span>            :         return end;</a>
<a name="516"><span class="lineNum">     516 </span>            : </a>
<a name="517"><span class="lineNum">     517 </span>            :     return it;</a>
<a name="518"><span class="lineNum">     518 </span>            : }</a>
<a name="519"><span class="lineNum">     519 </span>            : </a>
<a name="520"><span class="lineNum">     520 </span>            : #endif // QT_DEPRECATED_SINCE(5, 2)</a>
<a name="521"><span class="lineNum">     521 </span>            : </a>
<a name="522"><span class="lineNum">     522 </span>            : #ifdef Q_CC_CLANG</a>
<a name="523"><span class="lineNum">     523 </span>            : // Clang had a bug where __builtin_ctz/clz/popcount were not marked as constexpr.</a>
<a name="524"><span class="lineNum">     524 </span>            : #  if (defined __apple_build_version__ &amp;&amp;  __clang_major__ &gt;= 7) || (Q_CC_CLANG &gt;= 307)</a>
<a name="525"><span class="lineNum">     525 </span>            : #    define QT_HAS_CONSTEXPR_BUILTINS</a>
<a name="526"><span class="lineNum">     526 </span>            : #  endif</a>
<a name="527"><span class="lineNum">     527 </span>            : #elif defined(Q_CC_MSVC) &amp;&amp; !defined(Q_CC_INTEL) &amp;&amp; !defined(Q_PROCESSOR_ARM)</a>
<a name="528"><span class="lineNum">     528 </span>            : #  define QT_HAS_CONSTEXPR_BUILTINS</a>
<a name="529"><span class="lineNum">     529 </span>            : #elif defined(Q_CC_GNU)</a>
<a name="530"><span class="lineNum">     530 </span>            : #  define QT_HAS_CONSTEXPR_BUILTINS</a>
<a name="531"><span class="lineNum">     531 </span>            : #endif</a>
<a name="532"><span class="lineNum">     532 </span>            : </a>
<a name="533"><span class="lineNum">     533 </span>            : #if defined QT_HAS_CONSTEXPR_BUILTINS</a>
<a name="534"><span class="lineNum">     534 </span>            : #if defined(Q_CC_GNU) || defined(Q_CC_CLANG)</a>
<a name="535"><span class="lineNum">     535 </span>            : #  define QT_HAS_BUILTIN_CTZS</a>
<a name="536"><span class="lineNum">     536 </span>            : Q_DECL_CONSTEXPR Q_ALWAYS_INLINE uint qt_builtin_ctzs(quint16 v) noexcept</a>
<a name="537"><span class="lineNum">     537 </span>            : {</a>
<a name="538"><span class="lineNum">     538 </span>            : #  if __has_builtin(__builtin_ctzs)</a>
<a name="539"><span class="lineNum">     539 </span>            :     return __builtin_ctzs(v);</a>
<a name="540"><span class="lineNum">     540 </span>            : #  else</a>
<a name="541"><span class="lineNum">     541 </span>            :     return __builtin_ctz(v);</a>
<a name="542"><span class="lineNum">     542 </span>            : #  endif</a>
<a name="543"><span class="lineNum">     543 </span>            : }</a>
<a name="544"><span class="lineNum">     544 </span>            : #define QT_HAS_BUILTIN_CLZS</a>
<a name="545"><span class="lineNum">     545 </span>            : Q_DECL_CONSTEXPR Q_ALWAYS_INLINE uint qt_builtin_clzs(quint16 v) noexcept</a>
<a name="546"><span class="lineNum">     546 </span>            : {</a>
<a name="547"><span class="lineNum">     547 </span>            : #  if __has_builtin(__builtin_clzs)</a>
<a name="548"><span class="lineNum">     548 </span>            :     return __builtin_clzs(v);</a>
<a name="549"><span class="lineNum">     549 </span>            : #  else</a>
<a name="550"><span class="lineNum">     550 </span>            :     return __builtin_clz(v) - 16U;</a>
<a name="551"><span class="lineNum">     551 </span>            : #  endif</a>
<a name="552"><span class="lineNum">     552 </span>            : }</a>
<a name="553"><span class="lineNum">     553 </span>            : #define QT_HAS_BUILTIN_CTZ</a>
<a name="554"><span class="lineNum">     554 </span>            : Q_DECL_CONSTEXPR Q_ALWAYS_INLINE uint qt_builtin_ctz(quint32 v) noexcept</a>
<a name="555"><span class="lineNum">     555 </span>            : {</a>
<a name="556"><span class="lineNum">     556 </span><span class="lineNoCov">          0 :     return __builtin_ctz(v);</span></a>
<a name="557"><span class="lineNum">     557 </span>            : }</a>
<a name="558"><span class="lineNum">     558 </span>            : #define QT_HAS_BUILTIN_CLZ</a>
<a name="559"><span class="lineNum">     559 </span>            : Q_DECL_CONSTEXPR Q_ALWAYS_INLINE uint qt_builtin_clz(quint32 v) noexcept</a>
<a name="560"><span class="lineNum">     560 </span>            : {</a>
<a name="561"><span class="lineNum">     561 </span>            :     return __builtin_clz(v);</a>
<a name="562"><span class="lineNum">     562 </span>            : }</a>
<a name="563"><span class="lineNum">     563 </span>            : #define QT_HAS_BUILTIN_CTZLL</a>
<a name="564"><span class="lineNum">     564 </span>            : Q_DECL_CONSTEXPR Q_ALWAYS_INLINE uint qt_builtin_ctzll(quint64 v) noexcept</a>
<a name="565"><span class="lineNum">     565 </span>            : {</a>
<a name="566"><span class="lineNum">     566 </span>            :     return __builtin_ctzll(v);</a>
<a name="567"><span class="lineNum">     567 </span>            : }</a>
<a name="568"><span class="lineNum">     568 </span>            : #define QT_HAS_BUILTIN_CLZLL</a>
<a name="569"><span class="lineNum">     569 </span>            : Q_DECL_CONSTEXPR Q_ALWAYS_INLINE uint qt_builtin_clzll(quint64 v) noexcept</a>
<a name="570"><span class="lineNum">     570 </span>            : {</a>
<a name="571"><span class="lineNum">     571 </span>            :     return __builtin_clzll(v);</a>
<a name="572"><span class="lineNum">     572 </span>            : }</a>
<a name="573"><span class="lineNum">     573 </span>            : #define QALGORITHMS_USE_BUILTIN_POPCOUNT</a>
<a name="574"><span class="lineNum">     574 </span>            : Q_DECL_CONSTEXPR Q_ALWAYS_INLINE uint qt_builtin_popcount(quint32 v) noexcept</a>
<a name="575"><span class="lineNum">     575 </span>            : {</a>
<a name="576"><span class="lineNum">     576 </span>            :     return __builtin_popcount(v);</a>
<a name="577"><span class="lineNum">     577 </span>            : }</a>
<a name="578"><span class="lineNum">     578 </span>            : Q_DECL_CONSTEXPR Q_ALWAYS_INLINE uint qt_builtin_popcount(quint8 v) noexcept</a>
<a name="579"><span class="lineNum">     579 </span>            : {</a>
<a name="580"><span class="lineNum">     580 </span>            :     return __builtin_popcount(v);</a>
<a name="581"><span class="lineNum">     581 </span>            : }</a>
<a name="582"><span class="lineNum">     582 </span>            : Q_DECL_CONSTEXPR Q_ALWAYS_INLINE uint qt_builtin_popcount(quint16 v) noexcept</a>
<a name="583"><span class="lineNum">     583 </span>            : {</a>
<a name="584"><span class="lineNum">     584 </span>            :     return __builtin_popcount(v);</a>
<a name="585"><span class="lineNum">     585 </span>            : }</a>
<a name="586"><span class="lineNum">     586 </span>            : #define QALGORITHMS_USE_BUILTIN_POPCOUNTLL</a>
<a name="587"><span class="lineNum">     587 </span>            : Q_DECL_CONSTEXPR Q_ALWAYS_INLINE uint qt_builtin_popcountll(quint64 v) noexcept</a>
<a name="588"><span class="lineNum">     588 </span>            : {</a>
<a name="589"><span class="lineNum">     589 </span>            :     return __builtin_popcountll(v);</a>
<a name="590"><span class="lineNum">     590 </span>            : }</a>
<a name="591"><span class="lineNum">     591 </span>            : #elif defined(Q_CC_MSVC) &amp;&amp; !defined(Q_PROCESSOR_ARM)</a>
<a name="592"><span class="lineNum">     592 </span>            : #define QT_POPCOUNT_CONSTEXPR</a>
<a name="593"><span class="lineNum">     593 </span>            : #define QT_POPCOUNT_RELAXED_CONSTEXPR</a>
<a name="594"><span class="lineNum">     594 </span>            : #define QT_HAS_BUILTIN_CTZ</a>
<a name="595"><span class="lineNum">     595 </span>            : Q_ALWAYS_INLINE unsigned long qt_builtin_ctz(quint32 val)</a>
<a name="596"><span class="lineNum">     596 </span>            : {</a>
<a name="597"><span class="lineNum">     597 </span>            :     unsigned long result;</a>
<a name="598"><span class="lineNum">     598 </span>            :     _BitScanForward(&amp;result, val);</a>
<a name="599"><span class="lineNum">     599 </span>            :     return result;</a>
<a name="600"><span class="lineNum">     600 </span>            : }</a>
<a name="601"><span class="lineNum">     601 </span>            : #define QT_HAS_BUILTIN_CLZ</a>
<a name="602"><span class="lineNum">     602 </span>            : Q_ALWAYS_INLINE unsigned long qt_builtin_clz(quint32 val)</a>
<a name="603"><span class="lineNum">     603 </span>            : {</a>
<a name="604"><span class="lineNum">     604 </span>            :     unsigned long result;</a>
<a name="605"><span class="lineNum">     605 </span>            :     _BitScanReverse(&amp;result, val);</a>
<a name="606"><span class="lineNum">     606 </span>            :     // Now Invert the result: clz will count *down* from the msb to the lsb, so the msb index is 31</a>
<a name="607"><span class="lineNum">     607 </span>            :     // and the lsb index is 0. The result for the index when counting up: msb index is 0 (because it</a>
<a name="608"><span class="lineNum">     608 </span>            :     // starts there), and the lsb index is 31.</a>
<a name="609"><span class="lineNum">     609 </span>            :     result ^= sizeof(quint32) * 8 - 1;</a>
<a name="610"><span class="lineNum">     610 </span>            :     return result;</a>
<a name="611"><span class="lineNum">     611 </span>            : }</a>
<a name="612"><span class="lineNum">     612 </span>            : #if Q_PROCESSOR_WORDSIZE == 8</a>
<a name="613"><span class="lineNum">     613 </span>            : // These are only defined for 64bit builds.</a>
<a name="614"><span class="lineNum">     614 </span>            : #define QT_HAS_BUILTIN_CTZLL</a>
<a name="615"><span class="lineNum">     615 </span>            : Q_ALWAYS_INLINE unsigned long qt_builtin_ctzll(quint64 val)</a>
<a name="616"><span class="lineNum">     616 </span>            : {</a>
<a name="617"><span class="lineNum">     617 </span>            :     unsigned long result;</a>
<a name="618"><span class="lineNum">     618 </span>            :     _BitScanForward64(&amp;result, val);</a>
<a name="619"><span class="lineNum">     619 </span>            :     return result;</a>
<a name="620"><span class="lineNum">     620 </span>            : }</a>
<a name="621"><span class="lineNum">     621 </span>            : // MSVC calls it _BitScanReverse and returns the carry flag, which we don't need</a>
<a name="622"><span class="lineNum">     622 </span>            : #define QT_HAS_BUILTIN_CLZLL</a>
<a name="623"><span class="lineNum">     623 </span>            : Q_ALWAYS_INLINE unsigned long qt_builtin_clzll(quint64 val)</a>
<a name="624"><span class="lineNum">     624 </span>            : {</a>
<a name="625"><span class="lineNum">     625 </span>            :     unsigned long result;</a>
<a name="626"><span class="lineNum">     626 </span>            :     _BitScanReverse64(&amp;result, val);</a>
<a name="627"><span class="lineNum">     627 </span>            :     // see qt_builtin_clz</a>
<a name="628"><span class="lineNum">     628 </span>            :     result ^= sizeof(quint64) * 8 - 1;</a>
<a name="629"><span class="lineNum">     629 </span>            :     return result;</a>
<a name="630"><span class="lineNum">     630 </span>            : }</a>
<a name="631"><span class="lineNum">     631 </span>            : #endif // MSVC 64bit</a>
<a name="632"><span class="lineNum">     632 </span>            : #  define QT_HAS_BUILTIN_CTZS</a>
<a name="633"><span class="lineNum">     633 </span>            : Q_ALWAYS_INLINE uint qt_builtin_ctzs(quint16 v) noexcept</a>
<a name="634"><span class="lineNum">     634 </span>            : {</a>
<a name="635"><span class="lineNum">     635 </span>            :     return qt_builtin_ctz(v);</a>
<a name="636"><span class="lineNum">     636 </span>            : }</a>
<a name="637"><span class="lineNum">     637 </span>            : #define QT_HAS_BUILTIN_CLZS</a>
<a name="638"><span class="lineNum">     638 </span>            : Q_ALWAYS_INLINE uint qt_builtin_clzs(quint16 v) noexcept</a>
<a name="639"><span class="lineNum">     639 </span>            : {</a>
<a name="640"><span class="lineNum">     640 </span>            :     return qt_builtin_clz(v) - 16U;</a>
<a name="641"><span class="lineNum">     641 </span>            : }</a>
<a name="642"><span class="lineNum">     642 </span>            : </a>
<a name="643"><span class="lineNum">     643 </span>            : // Neither MSVC nor the Intel compiler define a macro for the POPCNT processor</a>
<a name="644"><span class="lineNum">     644 </span>            : // feature, so we're using either the SSE4.2 or the AVX macro as a proxy (Clang</a>
<a name="645"><span class="lineNum">     645 </span>            : // does define the macro). It's incorrect for two reasons:</a>
<a name="646"><span class="lineNum">     646 </span>            : // 1. It's a separate bit in CPUID, so a processor could implement SSE4.2 and</a>
<a name="647"><span class="lineNum">     647 </span>            : //    not POPCNT, but that's unlikely to happen.</a>
<a name="648"><span class="lineNum">     648 </span>            : // 2. There are processors that support POPCNT but not AVX (Intel Nehalem</a>
<a name="649"><span class="lineNum">     649 </span>            : //    architecture), but unlike the other compilers, MSVC has no option</a>
<a name="650"><span class="lineNum">     650 </span>            : //    to generate code for those processors.</a>
<a name="651"><span class="lineNum">     651 </span>            : // So it's an acceptable compromise.</a>
<a name="652"><span class="lineNum">     652 </span>            : #if defined(__AVX__) || defined(__SSE4_2__) || defined(__POPCNT__)</a>
<a name="653"><span class="lineNum">     653 </span>            : #define QALGORITHMS_USE_BUILTIN_POPCOUNT</a>
<a name="654"><span class="lineNum">     654 </span>            : #define QALGORITHMS_USE_BUILTIN_POPCOUNTLL</a>
<a name="655"><span class="lineNum">     655 </span>            : Q_ALWAYS_INLINE uint qt_builtin_popcount(quint32 v) noexcept</a>
<a name="656"><span class="lineNum">     656 </span>            : {</a>
<a name="657"><span class="lineNum">     657 </span>            :     return __popcnt(v);</a>
<a name="658"><span class="lineNum">     658 </span>            : }</a>
<a name="659"><span class="lineNum">     659 </span>            : Q_ALWAYS_INLINE uint qt_builtin_popcount(quint8 v) noexcept</a>
<a name="660"><span class="lineNum">     660 </span>            : {</a>
<a name="661"><span class="lineNum">     661 </span>            :     return __popcnt16(v);</a>
<a name="662"><span class="lineNum">     662 </span>            : }</a>
<a name="663"><span class="lineNum">     663 </span>            : Q_ALWAYS_INLINE uint qt_builtin_popcount(quint16 v) noexcept</a>
<a name="664"><span class="lineNum">     664 </span>            : {</a>
<a name="665"><span class="lineNum">     665 </span>            :     return __popcnt16(v);</a>
<a name="666"><span class="lineNum">     666 </span>            : }</a>
<a name="667"><span class="lineNum">     667 </span>            : Q_ALWAYS_INLINE uint qt_builtin_popcountll(quint64 v) noexcept</a>
<a name="668"><span class="lineNum">     668 </span>            : {</a>
<a name="669"><span class="lineNum">     669 </span>            : #if Q_PROCESSOR_WORDSIZE == 8</a>
<a name="670"><span class="lineNum">     670 </span>            :     return __popcnt64(v);</a>
<a name="671"><span class="lineNum">     671 </span>            : #else</a>
<a name="672"><span class="lineNum">     672 </span>            :     return __popcnt(quint32(v)) + __popcnt(quint32(v &gt;&gt; 32));</a>
<a name="673"><span class="lineNum">     673 </span>            : #endif // MSVC 64bit</a>
<a name="674"><span class="lineNum">     674 </span>            : }</a>
<a name="675"><span class="lineNum">     675 </span>            : </a>
<a name="676"><span class="lineNum">     676 </span>            : #endif // __AVX__ || __SSE4_2__ || __POPCNT__</a>
<a name="677"><span class="lineNum">     677 </span>            : </a>
<a name="678"><span class="lineNum">     678 </span>            : #endif // MSVC</a>
<a name="679"><span class="lineNum">     679 </span>            : #endif // QT_HAS_CONSTEXPR_BUILTINS</a>
<a name="680"><span class="lineNum">     680 </span>            : </a>
<a name="681"><span class="lineNum">     681 </span>            : #ifndef QT_POPCOUNT_CONSTEXPR</a>
<a name="682"><span class="lineNum">     682 </span>            : #define QT_POPCOUNT_CONSTEXPR Q_DECL_CONSTEXPR</a>
<a name="683"><span class="lineNum">     683 </span>            : #define QT_POPCOUNT_RELAXED_CONSTEXPR Q_DECL_RELAXED_CONSTEXPR</a>
<a name="684"><span class="lineNum">     684 </span>            : #endif</a>
<a name="685"><span class="lineNum">     685 </span>            : </a>
<a name="686"><span class="lineNum">     686 </span>            : } //namespace QAlgorithmsPrivate</a>
<a name="687"><span class="lineNum">     687 </span>            : </a>
<a name="688"><span class="lineNum">     688 </span>            : Q_DECL_CONST_FUNCTION QT_POPCOUNT_CONSTEXPR inline uint qPopulationCount(quint32 v) noexcept</a>
<a name="689"><span class="lineNum">     689 </span>            : {</a>
<a name="690"><span class="lineNum">     690 </span>            : #ifdef QALGORITHMS_USE_BUILTIN_POPCOUNT</a>
<a name="691"><span class="lineNum">     691 </span>            :     return QAlgorithmsPrivate::qt_builtin_popcount(v);</a>
<a name="692"><span class="lineNum">     692 </span>            : #else</a>
<a name="693"><span class="lineNum">     693 </span>            :     // See http://graphics.stanford.edu/~seander/bithacks.html#CountBitsSetParallel</a>
<a name="694"><span class="lineNum">     694 </span>            :     return</a>
<a name="695"><span class="lineNum">     695 </span>            :         (((v      ) &amp; 0xfff)    * Q_UINT64_C(0x1001001001001) &amp; Q_UINT64_C(0x84210842108421)) % 0x1f +</a>
<a name="696"><span class="lineNum">     696 </span>            :         (((v &gt;&gt; 12) &amp; 0xfff)    * Q_UINT64_C(0x1001001001001) &amp; Q_UINT64_C(0x84210842108421)) % 0x1f +</a>
<a name="697"><span class="lineNum">     697 </span>            :         (((v &gt;&gt; 24) &amp; 0xfff)    * Q_UINT64_C(0x1001001001001) &amp; Q_UINT64_C(0x84210842108421)) % 0x1f;</a>
<a name="698"><span class="lineNum">     698 </span>            : #endif</a>
<a name="699"><span class="lineNum">     699 </span>            : }</a>
<a name="700"><span class="lineNum">     700 </span>            : </a>
<a name="701"><span class="lineNum">     701 </span>            : Q_DECL_CONST_FUNCTION QT_POPCOUNT_CONSTEXPR inline uint qPopulationCount(quint8 v) noexcept</a>
<a name="702"><span class="lineNum">     702 </span>            : {</a>
<a name="703"><span class="lineNum">     703 </span>            : #ifdef QALGORITHMS_USE_BUILTIN_POPCOUNT</a>
<a name="704"><span class="lineNum">     704 </span>            :     return QAlgorithmsPrivate::qt_builtin_popcount(v);</a>
<a name="705"><span class="lineNum">     705 </span>            : #else</a>
<a name="706"><span class="lineNum">     706 </span>            :     return</a>
<a name="707"><span class="lineNum">     707 </span>            :         (((v      ) &amp; 0xfff)    * Q_UINT64_C(0x1001001001001) &amp; Q_UINT64_C(0x84210842108421)) % 0x1f;</a>
<a name="708"><span class="lineNum">     708 </span>            : #endif</a>
<a name="709"><span class="lineNum">     709 </span>            : }</a>
<a name="710"><span class="lineNum">     710 </span>            : </a>
<a name="711"><span class="lineNum">     711 </span>            : Q_DECL_CONST_FUNCTION QT_POPCOUNT_CONSTEXPR inline uint qPopulationCount(quint16 v) noexcept</a>
<a name="712"><span class="lineNum">     712 </span>            : {</a>
<a name="713"><span class="lineNum">     713 </span>            : #ifdef QALGORITHMS_USE_BUILTIN_POPCOUNT</a>
<a name="714"><span class="lineNum">     714 </span>            :     return QAlgorithmsPrivate::qt_builtin_popcount(v);</a>
<a name="715"><span class="lineNum">     715 </span>            : #else</a>
<a name="716"><span class="lineNum">     716 </span>            :     return</a>
<a name="717"><span class="lineNum">     717 </span>            :         (((v      ) &amp; 0xfff)    * Q_UINT64_C(0x1001001001001) &amp; Q_UINT64_C(0x84210842108421)) % 0x1f +</a>
<a name="718"><span class="lineNum">     718 </span>            :         (((v &gt;&gt; 12) &amp; 0xfff)    * Q_UINT64_C(0x1001001001001) &amp; Q_UINT64_C(0x84210842108421)) % 0x1f;</a>
<a name="719"><span class="lineNum">     719 </span>            : #endif</a>
<a name="720"><span class="lineNum">     720 </span>            : }</a>
<a name="721"><span class="lineNum">     721 </span>            : </a>
<a name="722"><span class="lineNum">     722 </span>            : Q_DECL_CONST_FUNCTION QT_POPCOUNT_CONSTEXPR inline uint qPopulationCount(quint64 v) noexcept</a>
<a name="723"><span class="lineNum">     723 </span>            : {</a>
<a name="724"><span class="lineNum">     724 </span>            : #ifdef QALGORITHMS_USE_BUILTIN_POPCOUNTLL</a>
<a name="725"><span class="lineNum">     725 </span>            :     return QAlgorithmsPrivate::qt_builtin_popcountll(v);</a>
<a name="726"><span class="lineNum">     726 </span>            : #else</a>
<a name="727"><span class="lineNum">     727 </span>            :     return</a>
<a name="728"><span class="lineNum">     728 </span>            :         (((v      ) &amp; 0xfff)    * Q_UINT64_C(0x1001001001001) &amp; Q_UINT64_C(0x84210842108421)) % 0x1f +</a>
<a name="729"><span class="lineNum">     729 </span>            :         (((v &gt;&gt; 12) &amp; 0xfff)    * Q_UINT64_C(0x1001001001001) &amp; Q_UINT64_C(0x84210842108421)) % 0x1f +</a>
<a name="730"><span class="lineNum">     730 </span>            :         (((v &gt;&gt; 24) &amp; 0xfff)    * Q_UINT64_C(0x1001001001001) &amp; Q_UINT64_C(0x84210842108421)) % 0x1f +</a>
<a name="731"><span class="lineNum">     731 </span>            :         (((v &gt;&gt; 36) &amp; 0xfff)    * Q_UINT64_C(0x1001001001001) &amp; Q_UINT64_C(0x84210842108421)) % 0x1f +</a>
<a name="732"><span class="lineNum">     732 </span>            :         (((v &gt;&gt; 48) &amp; 0xfff)    * Q_UINT64_C(0x1001001001001) &amp; Q_UINT64_C(0x84210842108421)) % 0x1f +</a>
<a name="733"><span class="lineNum">     733 </span>            :         (((v &gt;&gt; 60) &amp; 0xfff)    * Q_UINT64_C(0x1001001001001) &amp; Q_UINT64_C(0x84210842108421)) % 0x1f;</a>
<a name="734"><span class="lineNum">     734 </span>            : #endif</a>
<a name="735"><span class="lineNum">     735 </span>            : }</a>
<a name="736"><span class="lineNum">     736 </span>            : </a>
<a name="737"><span class="lineNum">     737 </span>            : Q_DECL_CONST_FUNCTION QT_POPCOUNT_CONSTEXPR inline uint qPopulationCount(long unsigned int v) noexcept</a>
<a name="738"><span class="lineNum">     738 </span>            : {</a>
<a name="739"><span class="lineNum">     739 </span>            :     return qPopulationCount(static_cast&lt;quint64&gt;(v));</a>
<a name="740"><span class="lineNum">     740 </span>            : }</a>
<a name="741"><span class="lineNum">     741 </span>            : </a>
<a name="742"><span class="lineNum">     742 </span>            : #if defined(Q_CC_GNU) &amp;&amp; !defined(Q_CC_CLANG)</a>
<a name="743"><span class="lineNum">     743 </span>            : #undef QALGORITHMS_USE_BUILTIN_POPCOUNT</a>
<a name="744"><span class="lineNum">     744 </span>            : #endif</a>
<a name="745"><span class="lineNum">     745 </span>            : #undef QT_POPCOUNT_CONSTEXPR</a>
<a name="746"><span class="lineNum">     746 </span>            : </a>
<a name="747"><span class="lineNum">     747 </span><span class="lineNoCov">          0 : Q_DECL_RELAXED_CONSTEXPR inline uint qCountTrailingZeroBits(quint32 v) noexcept</span></a>
<a name="748"><span class="lineNum">     748 </span>            : {</a>
<a name="749"><span class="lineNum">     749 </span>            : #if defined(QT_HAS_BUILTIN_CTZ)</a>
<a name="750"><span class="lineNum">     750 </span><span class="lineNoCov">          0 :     return v ? QAlgorithmsPrivate::qt_builtin_ctz(v) : 32U;</span></a>
<a name="751"><span class="lineNum">     751 </span>            : #else</a>
<a name="752"><span class="lineNum">     752 </span>            :     // see http://graphics.stanford.edu/~seander/bithacks.html#ZerosOnRightParallel</a>
<a name="753"><span class="lineNum">     753 </span>            :     unsigned int c = 32; // c will be the number of zero bits on the right</a>
<a name="754"><span class="lineNum">     754 </span>            :     v &amp;= -signed(v);</a>
<a name="755"><span class="lineNum">     755 </span>            :     if (v) c--;</a>
<a name="756"><span class="lineNum">     756 </span>            :     if (v &amp; 0x0000FFFF) c -= 16;</a>
<a name="757"><span class="lineNum">     757 </span>            :     if (v &amp; 0x00FF00FF) c -= 8;</a>
<a name="758"><span class="lineNum">     758 </span>            :     if (v &amp; 0x0F0F0F0F) c -= 4;</a>
<a name="759"><span class="lineNum">     759 </span>            :     if (v &amp; 0x33333333) c -= 2;</a>
<a name="760"><span class="lineNum">     760 </span>            :     if (v &amp; 0x55555555) c -= 1;</a>
<a name="761"><span class="lineNum">     761 </span>            :     return c;</a>
<a name="762"><span class="lineNum">     762 </span>            : #endif</a>
<a name="763"><span class="lineNum">     763 </span>            : }</a>
<a name="764"><span class="lineNum">     764 </span>            : </a>
<a name="765"><span class="lineNum">     765 </span>            : Q_DECL_RELAXED_CONSTEXPR inline uint qCountTrailingZeroBits(quint8 v) noexcept</a>
<a name="766"><span class="lineNum">     766 </span>            : {</a>
<a name="767"><span class="lineNum">     767 </span>            : #if defined(QT_HAS_BUILTIN_CTZ)</a>
<a name="768"><span class="lineNum">     768 </span>            :     return v ? QAlgorithmsPrivate::qt_builtin_ctz(v) : 8U;</a>
<a name="769"><span class="lineNum">     769 </span>            : #else</a>
<a name="770"><span class="lineNum">     770 </span>            :     unsigned int c = 8; // c will be the number of zero bits on the right</a>
<a name="771"><span class="lineNum">     771 </span>            :     v &amp;= -signed(v);</a>
<a name="772"><span class="lineNum">     772 </span>            :     if (v) c--;</a>
<a name="773"><span class="lineNum">     773 </span>            :     if (v &amp; 0x0000000F) c -= 4;</a>
<a name="774"><span class="lineNum">     774 </span>            :     if (v &amp; 0x00000033) c -= 2;</a>
<a name="775"><span class="lineNum">     775 </span>            :     if (v &amp; 0x00000055) c -= 1;</a>
<a name="776"><span class="lineNum">     776 </span>            :     return c;</a>
<a name="777"><span class="lineNum">     777 </span>            : #endif</a>
<a name="778"><span class="lineNum">     778 </span>            : }</a>
<a name="779"><span class="lineNum">     779 </span>            : </a>
<a name="780"><span class="lineNum">     780 </span>            : Q_DECL_RELAXED_CONSTEXPR inline uint qCountTrailingZeroBits(quint16 v) noexcept</a>
<a name="781"><span class="lineNum">     781 </span>            : {</a>
<a name="782"><span class="lineNum">     782 </span>            : #if defined(QT_HAS_BUILTIN_CTZS)</a>
<a name="783"><span class="lineNum">     783 </span>            :     return v ? QAlgorithmsPrivate::qt_builtin_ctzs(v) : 16U;</a>
<a name="784"><span class="lineNum">     784 </span>            : #else</a>
<a name="785"><span class="lineNum">     785 </span>            :     unsigned int c = 16; // c will be the number of zero bits on the right</a>
<a name="786"><span class="lineNum">     786 </span>            :     v &amp;= -signed(v);</a>
<a name="787"><span class="lineNum">     787 </span>            :     if (v) c--;</a>
<a name="788"><span class="lineNum">     788 </span>            :     if (v &amp; 0x000000FF) c -= 8;</a>
<a name="789"><span class="lineNum">     789 </span>            :     if (v &amp; 0x00000F0F) c -= 4;</a>
<a name="790"><span class="lineNum">     790 </span>            :     if (v &amp; 0x00003333) c -= 2;</a>
<a name="791"><span class="lineNum">     791 </span>            :     if (v &amp; 0x00005555) c -= 1;</a>
<a name="792"><span class="lineNum">     792 </span>            :     return c;</a>
<a name="793"><span class="lineNum">     793 </span>            : #endif</a>
<a name="794"><span class="lineNum">     794 </span>            : }</a>
<a name="795"><span class="lineNum">     795 </span>            : </a>
<a name="796"><span class="lineNum">     796 </span>            : Q_DECL_RELAXED_CONSTEXPR inline uint qCountTrailingZeroBits(quint64 v) noexcept</a>
<a name="797"><span class="lineNum">     797 </span>            : {</a>
<a name="798"><span class="lineNum">     798 </span>            : #if defined(QT_HAS_BUILTIN_CTZLL)</a>
<a name="799"><span class="lineNum">     799 </span>            :     return v ? QAlgorithmsPrivate::qt_builtin_ctzll(v) : 64;</a>
<a name="800"><span class="lineNum">     800 </span>            : #else</a>
<a name="801"><span class="lineNum">     801 </span>            :     quint32 x = static_cast&lt;quint32&gt;(v);</a>
<a name="802"><span class="lineNum">     802 </span>            :     return x ? qCountTrailingZeroBits(x)</a>
<a name="803"><span class="lineNum">     803 </span>            :              : 32 + qCountTrailingZeroBits(static_cast&lt;quint32&gt;(v &gt;&gt; 32));</a>
<a name="804"><span class="lineNum">     804 </span>            : #endif</a>
<a name="805"><span class="lineNum">     805 </span>            : }</a>
<a name="806"><span class="lineNum">     806 </span>            : </a>
<a name="807"><span class="lineNum">     807 </span>            : Q_DECL_RELAXED_CONSTEXPR inline uint qCountTrailingZeroBits(unsigned long v) noexcept</a>
<a name="808"><span class="lineNum">     808 </span>            : {</a>
<a name="809"><span class="lineNum">     809 </span>            :     return qCountTrailingZeroBits(QIntegerForSizeof&lt;long&gt;::Unsigned(v));</a>
<a name="810"><span class="lineNum">     810 </span>            : }</a>
<a name="811"><span class="lineNum">     811 </span>            : </a>
<a name="812"><span class="lineNum">     812 </span>            : Q_DECL_RELAXED_CONSTEXPR inline uint qCountLeadingZeroBits(quint32 v) noexcept</a>
<a name="813"><span class="lineNum">     813 </span>            : {</a>
<a name="814"><span class="lineNum">     814 </span>            : #if defined(QT_HAS_BUILTIN_CLZ)</a>
<a name="815"><span class="lineNum">     815 </span>            :     return v ? QAlgorithmsPrivate::qt_builtin_clz(v) : 32U;</a>
<a name="816"><span class="lineNum">     816 </span>            : #else</a>
<a name="817"><span class="lineNum">     817 </span>            :     // Hacker's Delight, 2nd ed. Fig 5-16, p. 102</a>
<a name="818"><span class="lineNum">     818 </span>            :     v = v | (v &gt;&gt; 1);</a>
<a name="819"><span class="lineNum">     819 </span>            :     v = v | (v &gt;&gt; 2);</a>
<a name="820"><span class="lineNum">     820 </span>            :     v = v | (v &gt;&gt; 4);</a>
<a name="821"><span class="lineNum">     821 </span>            :     v = v | (v &gt;&gt; 8);</a>
<a name="822"><span class="lineNum">     822 </span>            :     v = v | (v &gt;&gt; 16);</a>
<a name="823"><span class="lineNum">     823 </span>            :     return qPopulationCount(~v);</a>
<a name="824"><span class="lineNum">     824 </span>            : #endif</a>
<a name="825"><span class="lineNum">     825 </span>            : }</a>
<a name="826"><span class="lineNum">     826 </span>            : </a>
<a name="827"><span class="lineNum">     827 </span>            : QT_POPCOUNT_RELAXED_CONSTEXPR inline uint qCountLeadingZeroBits(quint8 v) noexcept</a>
<a name="828"><span class="lineNum">     828 </span>            : {</a>
<a name="829"><span class="lineNum">     829 </span>            : #if defined(QT_HAS_BUILTIN_CLZ)</a>
<a name="830"><span class="lineNum">     830 </span>            :     return v ? QAlgorithmsPrivate::qt_builtin_clz(v)-24U : 8U;</a>
<a name="831"><span class="lineNum">     831 </span>            : #else</a>
<a name="832"><span class="lineNum">     832 </span>            :     v = v | (v &gt;&gt; 1);</a>
<a name="833"><span class="lineNum">     833 </span>            :     v = v | (v &gt;&gt; 2);</a>
<a name="834"><span class="lineNum">     834 </span>            :     v = v | (v &gt;&gt; 4);</a>
<a name="835"><span class="lineNum">     835 </span>            :     return qPopulationCount(static_cast&lt;quint8&gt;(~v));</a>
<a name="836"><span class="lineNum">     836 </span>            : #endif</a>
<a name="837"><span class="lineNum">     837 </span>            : }</a>
<a name="838"><span class="lineNum">     838 </span>            : </a>
<a name="839"><span class="lineNum">     839 </span>            : QT_POPCOUNT_RELAXED_CONSTEXPR inline uint qCountLeadingZeroBits(quint16 v) noexcept</a>
<a name="840"><span class="lineNum">     840 </span>            : {</a>
<a name="841"><span class="lineNum">     841 </span>            : #if defined(QT_HAS_BUILTIN_CLZS)</a>
<a name="842"><span class="lineNum">     842 </span>            :     return v ? QAlgorithmsPrivate::qt_builtin_clzs(v) : 16U;</a>
<a name="843"><span class="lineNum">     843 </span>            : #else</a>
<a name="844"><span class="lineNum">     844 </span>            :     v = v | (v &gt;&gt; 1);</a>
<a name="845"><span class="lineNum">     845 </span>            :     v = v | (v &gt;&gt; 2);</a>
<a name="846"><span class="lineNum">     846 </span>            :     v = v | (v &gt;&gt; 4);</a>
<a name="847"><span class="lineNum">     847 </span>            :     v = v | (v &gt;&gt; 8);</a>
<a name="848"><span class="lineNum">     848 </span>            :     return qPopulationCount(static_cast&lt;quint16&gt;(~v));</a>
<a name="849"><span class="lineNum">     849 </span>            : #endif</a>
<a name="850"><span class="lineNum">     850 </span>            : }</a>
<a name="851"><span class="lineNum">     851 </span>            : </a>
<a name="852"><span class="lineNum">     852 </span>            : QT_POPCOUNT_RELAXED_CONSTEXPR inline uint qCountLeadingZeroBits(quint64 v) noexcept</a>
<a name="853"><span class="lineNum">     853 </span>            : {</a>
<a name="854"><span class="lineNum">     854 </span>            : #if defined(QT_HAS_BUILTIN_CLZLL)</a>
<a name="855"><span class="lineNum">     855 </span>            :     return v ? QAlgorithmsPrivate::qt_builtin_clzll(v) : 64U;</a>
<a name="856"><span class="lineNum">     856 </span>            : #else</a>
<a name="857"><span class="lineNum">     857 </span>            :     v = v | (v &gt;&gt; 1);</a>
<a name="858"><span class="lineNum">     858 </span>            :     v = v | (v &gt;&gt; 2);</a>
<a name="859"><span class="lineNum">     859 </span>            :     v = v | (v &gt;&gt; 4);</a>
<a name="860"><span class="lineNum">     860 </span>            :     v = v | (v &gt;&gt; 8);</a>
<a name="861"><span class="lineNum">     861 </span>            :     v = v | (v &gt;&gt; 16);</a>
<a name="862"><span class="lineNum">     862 </span>            :     v = v | (v &gt;&gt; 32);</a>
<a name="863"><span class="lineNum">     863 </span>            :     return qPopulationCount(~v);</a>
<a name="864"><span class="lineNum">     864 </span>            : #endif</a>
<a name="865"><span class="lineNum">     865 </span>            : }</a>
<a name="866"><span class="lineNum">     866 </span>            : </a>
<a name="867"><span class="lineNum">     867 </span>            : QT_POPCOUNT_RELAXED_CONSTEXPR inline uint qCountLeadingZeroBits(unsigned long v) noexcept</a>
<a name="868"><span class="lineNum">     868 </span>            : {</a>
<a name="869"><span class="lineNum">     869 </span>            :     return qCountLeadingZeroBits(QIntegerForSizeof&lt;long&gt;::Unsigned(v));</a>
<a name="870"><span class="lineNum">     870 </span>            : }</a>
<a name="871"><span class="lineNum">     871 </span>            : </a>
<a name="872"><span class="lineNum">     872 </span>            : QT_WARNING_POP</a>
<a name="873"><span class="lineNum">     873 </span>            : QT_END_NAMESPACE</a>
<a name="874"><span class="lineNum">     874 </span>            : </a>
<a name="875"><span class="lineNum">     875 </span>            : #endif // QALGORITHMS_H</a>
</pre>
      </td>
    </tr>
  </table>
  <br>

  <table width="100%" border=0 cellspacing=0 cellpadding=0>
    <tr><td class="ruler"><img src="../glass.png" width=3 height=3 alt=""></td></tr>
    <tr><td class="versionInfo">Generated by: <a href="http://ltp.sourceforge.net/coverage/lcov.php" target="_parent">LCOV version 1.14</a></td></tr>
  </table>
  <br>

</body>
</html>
